<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="java.util.*,java.io.*,imagemed.imsession.*,imagemed.dotcom.*,imagemed.util.*,imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%IMSession is = new IMSession( request, response, out ); 
	String strViewSessionID = request.getParameter( "ViewSessionID" );
	is.bRegNotNeeded = request.getParameter( "r_no_refresh" ) != null;

	boolean touchOnly = request.getParameter( "TouchOnly" ) != null;

	if ( touchOnly ) {
		is.regIP = request.getParameter( "IP" );
	}

	if ( !is.regOK() ) {
		return;
	}

	response.setContentType( "text/plain" );
	response.setHeader( "Pragma","no-cache" );

	// Keeping login alive from child server after redirecting getpbs
	if ( touchOnly ) {
		out.println( "true" );
		return;
	}

	// Check if login should be kept alive on the parent server (redirected getpbs)
	if ( !is.bRegNotNeeded ) {
		try {
			if ( is.isParentSession ) {
				String parentId = DotcomConfig.selfParent();
				if ( parentId != null ) {
					Dotcom.proxyURL( is, parentId, "/cases/activitysign.jsp?TouchOnly=true&IP=" + is.regIP, false, false );
				}
			}
		}
		catch ( Throwable th ) {
		}
	}

	StringBuilder strChanged = new StringBuilder();

	String strVidFileName = IMEnvBase.getEnv( "LOGIN_TMP" ) + "/" + strViewSessionID + ".vid";
	File fVidFile = new File( strVidFileName );
	if ( fVidFile.exists() ) {
		Helper.DEBUG( "vidfile exists:" + strVidFileName );
		
		HashMap<String, FingerPrint> vidFingerprints = VIDManager.readStudyFingerprintsFromVID( strViewSessionID );
		HashMap<String, FingerPrint> curFingerprints = VIDManager.rmiGetFingerPrints( null, new Vector<String>( vidFingerprints.keySet() ) );

		for ( String study : vidFingerprints.keySet() ) {
			if ( is.regID != null ) {
				Properties lockPrp = new Properties();
				IMLock.lockStudy( is, study, "CheckLock", lockPrp );
				String lockOwner = lockPrp.getProperty( "IMLockOwner" );
				String lockOwnerID = lockPrp.getProperty( "IMLockerID" );
				if ( !is.regID.equals( lockOwnerID ) ) {
					Helper.DEBUG( "activitysign.jsp", "lostlock: LostLock:" + study + " -> " + ( lockOwner == null ? "" : lockOwner ) );
					response.addHeader( "LostLock:" + study, lockOwner );
				}
			}

			FingerPrint vidFP = vidFingerprints.get( study );
			FingerPrint curFP = curFingerprints.get( study );
			
			if ( vidFP != null && curFP != null ) {
				Helper.DEBUG( "activitysign.jsp", "Comparing vid files for study " + study );
				Vector<String> changedObjects = curFP.getChangedList( vidFP );
				if ( changedObjects != null ) {
					for ( String obj : changedObjects ) {
						Helper.DEBUG( "activitysign.jsp", obj + " has changed for study " + study );
						strChanged.append( obj ).append( ";" );
					}
				}
			}
			else if ( vidFP == null ) {
				Helper.DEBUG( "activitysign.jsp", "Fingerprint in vid file is null or not yet updated for study " + study );
			}
			else {
				Helper.DEBUG( "activitysign.jsp", "Current fingerprint is null or could not be collected for study " + study );
			}
		}
	}
	
	ViewSessionProps.printViewSessionChanges( is );
	
	out.println( "# SessionID: " + is.regCookie );
	out.println( "# ViewSessionID: " + strViewSessionID );
	out.println( "# Viewer: " + ( is.bRegNotNeeded ? "Idle" : "Active" ) );
	if ( strChanged.length() > 0 ) {
		out.println( "# Changed: " + strChanged.toString() );
	}

	if ( true ) {
		// For avoiding extra new lines
		return;
	}%>
