#!/bin/sh
#
# Component: cases
#
# Description:
#  Retrieves dictation wave file from $REPOSITORY_CACHE.
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $DOCUMENT_ROOT/../etc/setenv.sh

# $PATH_INFO looks like "/styiuid/xxx.wav"
study=`echo "$PATH_INFO" | awk '{split($0,a,"/"); print a[2]}'`
file=`echo "$PATH_INFO" | awk '{split($0,a,"/"); print a[3]}'`
studydir=`$REPOSITORY_HANDLER_HOME/bin/locateResource $REPOSITORY_CACHE $study`
if [ $? -ne 0 ] ; then
  echo "Content-type: text/html"
  echo "Status: 403"
  echo
  echo "File not found: $PATH_INFO"
  exit 0
fi	

FILE="$studydir/$file"

if [ -f ${FILE} ] ; then
  echo "Content-type: audio/x-wav"
  echo "Content-length: `wc -c ${FILE} | sed 's/^ *\([^ ]*\) .*$/\1/'`"
  echo "Status: 200"
  echo
  cat ${FILE}
else
  echo "Content-type: text/html"
  echo "Status: 403"
  echo
  echo "File not found: $PATH_INFO"
fi
